/**
 * Container for objects that may contain either string or array of string as
 * values. Used to represent headers and query strings.
 *
 * @CLIENT-SERVER
 */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var 
Bucket = (function () {





  function Bucket() {_classCallCheck(this, Bucket);
    this._data = {};}


  /**
   * @param {string} key
   * @returns {boolean}
   */_createClass(Bucket, [{ key: 'has', value: 
    function has(key) {
      return this._data.hasOwnProperty(key);}


    /**
     * Returns
     *
     * @returns {{[key: string]: string | Array<string>}}
     */ }, { key: 'getAll', value: 
    function getAll() {
      return this._data;}


    /**
     * @param {string} key
     * @returns {string | Array<string>}
     */ }, { key: 'get', value: 
    function get(key) {
      return this._data[key];}


    /**
     * Set value, overwrites the given value.
     *
     * @param {string} key
     * @param {string | Array<string>} value
     */ }, { key: 'set', value: 
    function set(key, value) {
      this._data[key] = value;}


    /**
     * @param {string} key
     * @param {string | Array<string>} value
     */ }, { key: 'add', value: 
    function add(key, value) {
      if (!this._data.hasOwnProperty(key)) {
        this._data[key] = value;
        return;}


      if (Object.prototype.toString.call(this._data[key]) != '[object Array]') {
        this._data[key] = [this._data[key]];}


      this._data[key] = this._data[key].concat(value);} }, { key: 'remove', value: 


    function remove(key) {
      delete this._data[key];} }]);return Bucket;})();exports['default'] = Bucket;module.exports = exports['default']; /**
                                                                                                                        * @type {{[key: string]: string | Array<string>}}
                                                                                                                        */
//# sourceMappingURL=Bucket.js.map