/* @flow */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _PromiseUtilJs = require(

'./PromiseUtil.js');var _PromiseUtilJs2 = _interopRequireDefault(_PromiseUtilJs);

/*
type Query = {
  name: string;
  segmentId: string;
  query: any;
  forceLoad: ?boolean;
};
*/

/**
 * TODO: Remove after we established how to consistently do polyfills.
 */
var Promise;

/**
 * Represents a declarative query dependency requirements. Recursive, may
 * contain individual query objects or another QueryDependencies instance.
 * Each QueryDependencies instance can be either parallel or serial. Parallel
 * fetching doesn't care about order, serial fetching guarantees order based
 * on order of insertion.
 *
 * @CLIENT_SERVER
 */var 
QueryDependencies = (function () {















  /**
   * @param {Function} PromiseImpl
   * @param {boolean} isParallel
   */
  function QueryDependencies(PromiseImpl, isParallel) {_classCallCheck(this, QueryDependencies);
    Promise = PromiseImpl;
    this._isParallel = isParallel;
    this._queries = [];
    this._results = {};}


  /**
   * @param {Function} PromiseImpl
   * @returns {QueryDependencies}
   */_createClass(QueryDependencies, [{ key: 'getResult', 












    /**
     * @param {string} name
     * @return {Object} TODO: segment piece object, clarify.
     */value: 
    function getResult(name) {
      return this._results[name];}


    /**
     * @param {string} name
     * @param {string} segmentId
     * @param {any} query
     * @param {?boolean} forceLoad
     */ }, { key: 'add', value: 
    function add(name, segmentId, query, forceLoad) {
      this._ensureNoNameClash(name);
      this._queries.push({ 
        name: name, 
        segmentId: segmentId, 
        query: query, 
        forceLoad: forceLoad });}



    /**
     * @param {string} name
     * @param {Function} queryFunc
     */ }, { key: 'addFunction', value: 
    function addFunction(name, queryFunc) {
      this._ensureNoNameClash(name);
      this._queries.push({ 
        name: name, 
        segmentId: '', 
        query: queryFunc, 
        forceLoad: false });}



    /**
     * @param {string} name
     * @param {QueryDependencies} queryDependencies
     */ }, { key: 'addRecursive', value: 
    function addRecursive(name, queryDependencies) {
      this._ensureNoNameClash(name);
      this._results[name] = queryDependencies;
      this._queries.push({ 
        name: name, 
        segmentId: '', 
        query: queryDependencies, 
        forceLoad: null });}



    /**
     * Fetches all query dependencies, returns a promise that resolves when
     * all dependencies are successfully fetched.
     *
     * @param {ReduxStore} reduxStore
     * @return {Promise}
     */ }, { key: '_run', value: 
    function _run(reduxStore) {
      if (this._isParallel) {
        return this._runParallel(reduxStore);}

      return this._runSerial(reduxStore);}


    /**
     * @param {ReduxStore} reduxStore
     */ }, { key: '_runParallel', value: 
    function _runParallel(reduxStore) {
      var i, query, fetchPromise, promises = [];
      var queryFunc = reduxStore.query.bind(reduxStore);
      var dispatchFunc = reduxStore.dispatch.bind(reduxStore);
      for (i = 0; i < this._queries.length; i++) {
        query = this._queries[i];
        if (query.query instanceof QueryDependencies) {
          promises.push(query.query._run(reduxStore));
          continue;}


        // TODO: How does function sets values to results?
        // Promise returned by the function should resolve query result, whatever
        // it is (doesn't have to be a segment piece).
        if (typeof query.query == 'function') {
          promises.push(query.query(queryFunc, dispatchFunc).then(this._createResultSetterFunc(query.name)));
          continue;}


        // Construct a promise that sets the result to this instance after fetching is complete.
        fetchPromise = reduxStore.query(query.segmentId, query.query, query.forceLoad).then(
        this._createResultSetterFunc(query.name));


        promises.push(fetchPromise);}

      return _PromiseUtilJs2['default'].allParallel(Promise, promises);}


    /**
     * @param {ReduxStore} reduxStore
     * @return {Promise}
     */ }, { key: '_runSerial', value: 
    function _runSerial(reduxStore) {
      var i, query, ready = Promise.resolve(null);
      var queryFunc = reduxStore.query.bind(reduxStore);
      var dispatchFunc = reduxStore.dispatch.bind(reduxStore);
      for (i = 0; i < this._queries.length; i++) {
        query = this._queries[i];
        if (query.query instanceof QueryDependencies) {
          // No need to store query results.
          ready = ready.then(this._createSerialRecursiveQueryFunc(
          reduxStore, query.query));
          continue;}


        if (typeof query.query == 'function') {
          ready = ready.then(this._createSerialQueryFunc(queryFunc, dispatchFunc, query.query, query.name));
          continue;}


        // Chain the promises together, our onFulfilled function returns another
        // promise that will be executed, the next .then call will execute after
        // that promise is resolved.
        ready = ready.then(this._createSerialObjectQueryFunc(reduxStore, query));
        ready = ready.then(this._createResultSetterFunc(query.name));}


      // Since ready is a long chained promise, we don't need to manually set
      // reject function. It will bubble up to the top.
      return ready;}


    /**
     * @param {Function} queryFunc
     * @param {Function} dispatchFunc
     * @param {Function} query
     * @param {string} name
     */ }, { key: '_createSerialQueryFunc', value: 
    function _createSerialQueryFunc(queryFunc, dispatchFunc, query, name) {var _this = this;
      return function () {
        // We expect query functions to return a promise that resolves with the
        // result variable.
        return query(queryFunc, dispatchFunc).then(_this._createResultSetterFunc(name));};}



    /**
     * @param {ReduxStore}reduxStore
     * @param {Query} query
     * @returns {Promise}
     */ }, { key: '_createSerialObjectQueryFunc', value: 
    function _createSerialObjectQueryFunc(reduxStore, query) {
      return function () {
        return reduxStore.query(query.segmentId, query.query, query.forceLoad);};}



    /**
     * @param {ReduxStore} reduxStore
     * @param {QueryDependencies} queryDependencies
     * @return {Promise}
     */ }, { key: '_createSerialRecursiveQueryFunc', value: 
    function _createSerialRecursiveQueryFunc(reduxStore, queryDependencies) {
      return function () {
        return queryDependencies._run(reduxStore);};}



    /**
     * Creates a function that sets result with the given name using redux store.
     *
     * @param {string} name
     * @returns {Function}
     */ }, { key: '_createResultSetterFunc', value: 
    function _createResultSetterFunc(name) {var _this2 = this;
      return function (segmentPiece) {
        _this2._results[name] = segmentPiece;};}



    /**
     * @param {string} name
     */ }, { key: '_ensureNoNameClash', value: 
    function _ensureNoNameClash(name) {
      if (this._results.hasOwnProperty(name)) {
        throw new Error('Query dependencies name clash: \'' + name + '\'.');}

      this._results[name] = null;} }], [{ key: 'parallel', value: function parallel(PromiseImpl) {return new QueryDependencies(PromiseImpl, true);} /**
                                                                                                                                                     * @param {Function} PromiseImpl
                                                                                                                                                     * @returns {QueryDependencies}
                                                                                                                                                     */ }, { key: 'serial', value: function serial(PromiseImpl) {return new QueryDependencies(PromiseImpl, false);} }]);return QueryDependencies;})();exports['default'] = QueryDependencies;module.exports = exports['default']; /**
                                                                                                                                                                                                                                                                                                                                                                                   * @type {boolean}
                                                                                                                                                                                                                                                                                                                                                                                   */ /**
                                                                                                                                                                                                                                                                                                                                                                                       * @type {Array<Query | QueryDependencies>}
                                                                                                                                                                                                                                                                                                                                                                                       */ /**
                                                                                                                                                                                                                                                                                                                                                                                           * @type {{[key: string]: Object}}
                                                                                                                                                                                                                                                                                                                                                                                           */
//# sourceMappingURL=QueryDependencies.js.map