'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _httpServerHttpRequest = require('../http/ServerHttpRequest');var _httpServerHttpRequest2 = _interopRequireDefault(_httpServerHttpRequest);var _RouteResult = require(
'./RouteResult');var _RouteResult2 = _interopRequireDefault(_RouteResult);var _PathNode = require(
'./PathNode');var _PathNode2 = _interopRequireDefault(_PathNode);

/**
 * Represents initial routing data and routing results.
 *
 * @SERVER
 */var 
RoutingData = (function () {






























  /**
   * @param {ServerHttpRequest} serverHttpRequest
   */
  function RoutingData(serverHttpRequest) {_classCallCheck(this, RoutingData);
    this.serverHttpRequest = serverHttpRequest;
    this._currentSegmentIndex = 0;
    this.resultRouteArgs = {};
    this._pathSegments = _PathNode2['default'].toPathSegments(this.serverHttpRequest.getPath());}


  /**
   * @returns {boolean}
   */_createClass(RoutingData, [{ key: 'isEmptyPath', value: 
    function isEmptyPath() {
      return this._pathSegments.length == 0;}


    /**
     * Consumes current segment, prompting next node to use the next path segment.
     */ }, { key: 'consumeSegment', value: 
    function consumeSegment() {
      this._currentSegmentIndex++;}


    /**
     * Undoes the segment consumption.
     */ }, { key: 'undoConsumeSegment', value: 
    function undoConsumeSegment() {
      this._currentSegmentIndex--;
      if (this._currentSegmentIndex < 0) this._currentSegmentIndex = 0;}


    /**
     * @returns {boolean}
     */ }, { key: 'isAllSegmentConsumed', value: 
    function isAllSegmentConsumed() {
      return this._currentSegmentIndex > this._pathSegments.length - 1;}


    /**
     * @returns {?string}
     */ }, { key: 'getCurrentSegment', value: 
    function getCurrentSegment() {
      if (this.isAllSegmentConsumed()) {
        return null;}

      return this._pathSegments[this._currentSegmentIndex];}


    /**
     * @returns {RouteResult}
     */ }, { key: 'createResult', value: 
    function createResult() {
      if (!this.resultRouteId || !this.resultPageName) {
        return null;}

      var result = new _RouteResult2['default']();
      result.routeId = this.resultRouteId;
      result.pageName = this.resultPageName;
      result.routeArgs = this.resultRouteArgs;
      return result;} }]);return RoutingData;})();exports['default'] = RoutingData;module.exports = exports['default']; /**
                                                                                                                         * @type {ServerHttpRequest}
                                                                                                                         */ /**
                                                                                                                             * @type {Object}
                                                                                                                             */ /**
                                                                                                                                 * @type {string}
                                                                                                                                 */ /**
                                                                                                                                     * @type {string}
                                                                                                                                     */ /**
                                                                                                                                         * @type {Array<string>}
                                                                                                                                         */ /**
                                                                                                                                             * @type {number}
                                                                                                                                             */
//# sourceMappingURL=RoutingData.js.map